'use strict';Object.defineProperty(exports,'__esModule',{value:true});exports.default=function(req,res,clean){if(!clean){return}if(typeof clean!=='boolean'&&!Array.isArray(clean)){throw new TypeError('"cleanUrls" must be a boolean or an array')}/* if we have sources, make sure one of them matches url */if(Array.isArray(clean)){/* check if the uri is a match for one of the patterns */const match=(0,_pattern.findMatch)(clean,req.uri);/* no match was found, abort cleanup */if(!match){return}}/* if url is dirty, clean it and redirect */if(isDirty(req.uri)){const cleanUrl=cleanup(req.uri);Object.assign(res,(0,_redirect.redirect)(cleanUrl));return}/* if using clean urls, add extension for origin lookups */req.uri=addExtension(req.uri)};exports.isDirty=isDirty;exports.cleanup=cleanup;exports.addExtension=addExtension;var _path=require('path');var _path2=_interopRequireDefault(_path);var _pattern=require('../utils/pattern');var _redirect=require('./redirect');function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}const PATTERN_HTML=/\.html?$/i;const PATTERN_INDEX=/index(?:\.html?)?$/i;/**
 * determines whether a url needs
 * to be redirected to a "cleaned up"
 * version or not
 */function isDirty(uri){return PATTERN_HTML.test(uri)||PATTERN_INDEX.test(uri)}/**
 * cleans up a dirty url by removing
 * html extensions and index files
 */function cleanup(uri){return uri.replace(PATTERN_HTML,'').replace(PATTERN_INDEX,'')}/**
 * adds an html extension for origin
 * lookups on routes that were cleaned
 * up and don't have an extension
 */function addExtension(uri){const needsExtension=uri.slice(-1)!=='/'&&!_path2.default.extname(uri);return needsExtension?`${uri}.html`:uri}