'use strict';Object.defineProperty(exports,'__esModule',{value:true});exports.default=function(req,res,redirects=[]){if(!Array.isArray(redirects)){throw new TypeError('"redirects" must be an array')}/* strip out each source pattern */const sources=redirects.map(i=>i.source);/* go through each redirect and look for a match */const match=(0,_pattern.findMatch)(sources,req.uri);if(match){/* match found, convert to new pattern and redirect */const data=redirects[match.index];const rendered=(0,_pattern2.default)(data.source,data.to,req.uri);Object.assign(res,redirect(rendered,data.code))}};exports.redirect=redirect;var _http=require('http');var _pattern=require('../utils/pattern');var _pattern2=_interopRequireDefault(_pattern);function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}/**
 * generates a lambda response object
 * specific to a CloudFront redirect
 */function redirect(to,code=301){/* make sure the status code is an int */const status=parseInt(code,10);/* make sure status is a valid redirect code */if(status<300||status>308){throw new Error(`${status} is not a valid redirect status code`)}return{status:String(status),/* CF expects status as a string */statusDescription:_http.STATUS_CODES[status],body:`Redirecting to ${to}`,headers:{'content-type':[{key:'Content-Type',value:'text/plain; charset=UTF-8'}],location:[{key:'Location',value:to}]}}}